/* _NVRM_COPYRIGHT_BEGIN_
 *
 * Copyright 2020-2021 by NVIDIA Corporation.  All rights reserved.  All
 * information contained herein is proprietary and confidential to NVIDIA
 * Corporation.  Any use, reproduction, or disclosure without the written
 * permission of NVIDIA Corporation is prohibited.
 *
 * _NVRM_COPYRIGHT_END_
 */

/* Compiler headers */
#include <stdbool.h>

/* Early FSP headers */

/* Hardware headers */

/* Late FSP headers */
#include <misc/macros.h>                   // for START_RFD_BLOCK, END_RFD_BLOCK, INLINE_RFD

/* Module-specific FSP headers */
#include <cpu/shutdown.h>
#include <cpu/sbi.h>

START_RFD_BLOCK(MISRA, DEVIATE, Rule_1_2, "Approval: Bug 200531996, DR: SWE-FSP-009-SWSADR.docx",
                MISRA, DEVIATE, Directive_4_9, "Approval: Bug 200531995, DR: SWE-FSP-012-SWSADR.docx")

__attribute__ ((noreturn))
__attribute__((__optimize__("no-stack-protector")))
void riscvPanic(void)
{
    (void) sbicall0((int32_t) SBI_EXTENSION_SHUTDOWN, (int32_t) SBI_NVFUNC_FIRST);
    while(true) {}
}

__attribute__ ((noreturn))
__attribute__((__optimize__("no-stack-protector")))
void riscvShutdown(void)
{
    (void) sbicall0((int32_t) SBI_EXTENSION_SHUTDOWN, (int32_t) SBI_NVFUNC_FIRST);
    while(true) {}
}

END_RFD_BLOCK(MISRA, DEVIATE, Rule_1_2, "Approval: Bug 200531996, DR: SWE-FSP-009-SWSADR.docx",
              MISRA, DEVIATE, Directive_4_9, "Approval: Bug 200531995, DR: SWE-FSP-012-SWSADR.docx")
