/* _NVRM_COPYRIGHT_BEGIN_
 *
 * Copyright 2020-2021 by NVIDIA Corporation.  All rights reserved.  All
 * information contained herein is proprietary and confidential to NVIDIA
 * Corporation.  Any use, reproduction, or disclosure without the written
 * permission of NVIDIA Corporation is prohibited.
 *
 * _NVRM_COPYRIGHT_END_
 */

#include <cpu/csr.h>
#include <cpu/asm-helpers.h>

.section ".text.startup","ax",@progbits
.balign 4
FUNC startup
    j    do_reset

do_reset:
    ZREG(x1)
    ZREG(x2)
    ZREG(x3)
    ZREG(x4)
    ZREG(x5)
    ZREG(x6)
    ZREG(x7)
    ZREG(x8)
    ZREG(x9)
    ZREG(x10)
    ZREG(x11)
    ZREG(x12)
    ZREG(x13)
    ZREG(x14)
    ZREG(x15)
    ZREG(x16)
    ZREG(x17)
    ZREG(x18)
    ZREG(x19)
    ZREG(x20)
    ZREG(x21)
    ZREG(x22)
    ZREG(x23)
    ZREG(x24)
    ZREG(x25)
    ZREG(x26)
    ZREG(x27)
    ZREG(x28)
    ZREG(x29)
    ZREG(x30)
    ZREG(x31)

    // write mtvec and make sure it sticks
    la    t0, riscvPanicTrampoline
    csrw  mtvec, t0
    csrw  stvec, t0

    la    sp, _stack_bottom
    ld    sp, 0(sp)
    addi  sp, sp, -0x10
    sd    zero, 0(sp)
    sd    zero, 8(sp)
    jal   main
    // halt the core one way or another
    jal   riscvShutdown
_end:
    j _end
EFUNC startup


.balign 4
FUNC riscvPanicTrampoline
    jal riscvPanic
EFUNC riscvPanicTrampoline

// We need that dereference to handle chips where dmem is far away from imem
  .balign 8
_stack_bottom:
  .dword _libnvriscv_stack_bottom
